//\Users\Munzn\AppData\Local\Arduino15\packages\esp8266\hardware\esp8266\2.4.2\tools\espota.py -i 192.168.178.41 -f C:\Users\Munzn\AppData\Local\Temp\arduino_build_177705\RGBSteuerung.ino.bin
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <PubSubClient.h>
#include <ArduinoOTA.h>
#include <FS.h>

#define pin_red 4
#define pin_green 12
#define pin_blue 14

uint32_t sendInfo = 0;

struct credentials_t
{
	char ssid[33];
	char pass[65];
	char hostnameESP[33];
	char mqttServerIP[16];
	char mqttTopic[100];
	
};
credentials_t credentials;

char configSSID[60];
uint32_t wifiNotConnectedSince = 0;
uint32_t lastSuccessfullPing = 0;
bool APStarted = false;

WiFiClient espClient;
PubSubClient mqtt(espClient);
char clientId[70];
uint32_t lastConnectToBroker = 0;
bool connectFirstTime = true;

ESP8266WebServer server(80);
char htmlBuffer[4000];
bool openConfigSite = false;

uint8_t telnetClients = 0;
bool ConnectionEstablished;
#define MAX_TELNET_CLIENTS 4
WiFiServer TelnetServer(23);
WiFiClient TelnetClient[MAX_TELNET_CLIENTS];

uint32_t previousMillis = 0;
uint32_t currentMillis = 0;
uint8_t r = 0;
uint8_t g = 0;
uint8_t b = 0;
uint8_t brightness = 250;
uint32_t fadeMillis = 0;
uint16_t fadeState = 0;
bool fade = false;
bool setOff = true;

void setup(){
    Serial.begin(115200);
    Serial.println("Start");

    analogWriteFreq(75);
    analogWriteRange(255);

    SPIFFS.begin();
   
    File f = SPIFFS.open("/credentials.txt", "r");
  
	if(f){
		
		f.read(reinterpret_cast<byte*>(&credentials), sizeof(credentials)); 
	    f.close();
	    
	}
	else
	{
		Serial.println("Error reading File credentials.txt using default values");
		sprintf(credentials.ssid, "%s", "Automatisierung");
		sprintf(credentials.pass, "%s", "PASSWORT123");
	 	sprintf(credentials.hostnameESP, "%s", "Dekolicht");
	 	sprintf(credentials.mqttServerIP, "%s", "192.168.0.2");
	 	sprintf(credentials.mqttTopic, "%s", "Garten/Beleuchtung/Dekolicht");
	 	
	}
    
    sprintf(configSSID, "config%s", credentials.hostnameESP);
    
    Serial.print("SSID: ");  
    Serial.println(credentials.ssid);
    Serial.print("PASS: ");  
    Serial.println(credentials.pass);
    Serial.print("MQTT Server IP: ");
    Serial.println(credentials.mqttServerIP);
    Serial.print("MQTT Topic: ");
    Serial.println(credentials.mqttTopic);
    Serial.print("Hostname ESP : ");
    Serial.println(credentials.hostnameESP);
    Serial.print("Config SSID: ");
    Serial.println(configSSID);    
    
    WiFi.disconnect();    //Alte Daten löschen
    WiFi.mode(WIFI_STA);
    WiFi.hostname(credentials.hostnameESP);
    WiFi.begin(credentials.ssid, credentials.pass);

    //Gleich zu beginn die richtige Farbe setzten -> neue version, AUS

    setColor(r, g, b, brightness);

    server.on("/", handleRoot);
    server.on("/update/credentials/", handleCredentialsUpdate);
    server.on("/update/ConfigServer/", handleOpenConfigSite);
    server.on("/colors/fade/", handleFade);
    server.on("/colors/set_red/", handleSetRed);
    server.on("/colors/set_green/", handleSetGreen);
    server.on("/colors/set_blue/", handleSetBlue);
    server.on("/colors/set_white/", handleSetWhite);
    server.on("/colors/set_off/", handleSetOff);
    server.on("/colors/brightness/", handleSetBrightness);
    server.onNotFound(handleNotFound);
    server.begin();

    mqtt.setServer(credentials.mqttServerIP, 1883);
    mqtt.setCallback(onMQTTMessageReceived);
    
    TelnetServer.begin();
    TelnetServer.setNoDelay(true);

    ArduinoOTA.begin();
    
    
}

void loop(){

    if(millis() - sendInfo > 10000){
        sendInfo = millis();
        sendWiFiInformation();
        Serial.println();
        sendMQTTInformation();
        Serial.println("---------------------------\n\r");
    }
    
    handleConnections();
    handleTelnet();
    server.handleClient(); 
    mqtt.loop();
    handleFadeing();
    ArduinoOTA.handle();

}
