void handleRoot(){

    if(WiFi.status() == WL_CONNECTED && !openConfigSite){
    
        sprintf(htmlBuffer, R"(

<html>
    <head>
      <title>Chamaeleon</title>
      <meta name='viewport' content='width=320px'>
      <meta charset='utf-8'>
      <script> function redirect(dir){var loc = '/colors/'+dir+'/'; window.location = loc; } </script>
    </head>
    <body>
      <div align='center'>
        <style> button { width: 300px; height: 50px; font-size: 18px; } </style>
        <h3>Was soll gemacht werden?</h3>
        <button onclick=redirect('set_red')>rot</button><br>
        <button onclick=redirect('set_green')>grün</button><br>
        <button onclick=redirect('set_blue')>blau</button><br>
        <button onclick=redirect('set_white')>weiß</button><br>
        <button onclick=redirect('set_off')>Aus</button><br>
        <p>
          <form method='post' action='/colors/brightness/'>
            <h3>Wie hell soll es leuchten?</h3>
            <input type='range' name='brightness' min='1' max='255' value='%d'>
            <input type='submit' value='übernehmen'>
          </form>
        </p>
        <p>
          <form method='post' action='/colors/fade/'>
            <h3>Langsamen Farbwechsel aktivieren?</h3>
            <input type='checkbox' name='fade'>
            <input type='submit' value='übernehmen'>
          </form>
        </p>
        <p>
          <form method='post' action='/update/ConfigServer/'>
            <h3>Configurationsseite öffnen</h3>
            <input type='checkbox' name='ConfigServer'>
            <input type='submit' value='übernehmen'>
          </form>
        </p>
        <p>Lightning 2018</p>
      </div>
    </body>
</html>)", brightness);

    }else{
        String ssids;
        int numberOfNetworks = WiFi.scanNetworks();
        for(int thisNetwork = 0; thisNetwork < numberOfNetworks; thisNetwork = thisNetwork + 1){
            ssids = ssids + WiFi.SSID(thisNetwork);
            ssids = ssids + "</option><option>";
        }
  
    sprintf(htmlBuffer, R"(   

<html>
    <head>
      <title>Chamaeleon</title>
      <meta name='viewport' content='width=320px'>
      <meta charset='utf-8'>
      <script> function redirect(dir){var loc = '/colors/'+dir+'/'; window.location = loc; } </script>
    </head>
    <body>
      <div align='center'>
        <form method='post' action='/update/credentials/'>
          <h5>Bitte wählen Sie Ihr Netzwerk aus</h5>
          <select name='ssid'>
            <option>%s</option>
          </select><br>
          <h5>Bitte geben Sie das Passwort Ihres W-Lan Netzes ein</h5>
          <input type='password' name='password' required minlength='8' maxlength='%d'/><br>
          <h5>Bitte geben Sie die IP-Adresse des MQTT Brokers ein (optional)</h5>
          <input type='text' name='mqttServerIP' value=%s minlength='7' maxlength='%d' pattern='((^|\.)((25[0-5])|(2[0-4]\d)|(1\d\d)|([1-9]?\d))){4}$'/><br>
          <h5>Bitte geben Sie das MQTT-Topic ein (optional)</h5>
          <input type='text' name='mqttTopict' value=%s maxlength='%d'/><br>
          <h5>Bitte geben Sie den Gerätenamen ein (optional)</h5>
          <input type='text' name='hostnameESP' value=%s maxlength='%d'/><br><br><br>
          <input type='submit' value='Speichern'/><br>
        </form>
        <style> button { width: 300px; height: 50px; font-size: 18px; } </style>
        <h2>Was soll gemacht werden?</h2>
        <button onclick=redirect('set_red')>rot</button><br>
        <button onclick=redirect('set_green')>grün</button><br>
        <button onclick=redirect('set_blue')>blau</button><br>
        <button onclick=redirect('set_white')>weiß</button><br>
        <button onclick=redirect('set_off')>Aus</button><br>
        <p>
          <form method='post' action='/colors/brightness/'>
            <input type='range' name='brightness' min='1' max='255' value=%d>
            <input type='submit' value='übernehmen'>
          </form>
        </p>
        <p>
          <form method='post' action='/colors/fade/'>
            <h3>Langsamen Farbwechsel aktivieren?</h3>
            <input type='checkbox' name='fade'>
            <input type='submit' value='übernehmen'>
          </form>
        </p>
        <p>Lightning 2018</p>
      </div>
    </body>
</html>)", ssids.c_str(), 
		   							 	(sizeof(credentials.pass)/sizeof(credentials.pass[0])) - 1, 
		   credentials.mqttServerIP, 	(sizeof(credentials.mqttServerIP)/sizeof(credentials.mqttServerIP[0])) - 1,
		   credentials.mqttTopic, 		(sizeof(credentials.mqttTopic)/sizeof(credentials.mqttTopic)) - 1, 
		   credentials.hostnameESP, 	(sizeof(credentials.hostnameESP)/sizeof(credentials.hostnameESP[0])) - 1, 
		   brightness);
  
  }

    server.send ( 200, "text/html", htmlBuffer);

}

void handleNotFound(){
	
    String message = "File Not Found\n\n";
    message += "URI: ";
    message += server.uri();
    message += "\nMethod: ";
    message += ( server.method() == HTTP_GET ) ? "GET" : "POST";
    message += "\nArguments: ";
    message += server.args();
    message += "\n";

    for ( uint8_t i = 0; i < server.args(); i++ ) {
        message += " " + server.argName ( i ) + ": " + server.arg ( i ) + "\n";
    }

    server.send ( 404, "text/plain", message );
}

void handleCredentialsUpdate(){ 
 
    server.arg(0).toCharArray(credentials.ssid, sizeof(credentials.ssid) / sizeof(credentials.ssid[0]));
    server.arg(1).toCharArray(credentials.pass, sizeof(credentials.pass) / sizeof(credentials.pass[0]));
    server.arg(2).toCharArray(credentials.mqttServerIP, sizeof(credentials.mqttServerIP) / sizeof(credentials.mqttServerIP[0]));
    server.arg(3).toCharArray(credentials.mqttTopic, sizeof(credentials.mqttTopic) / sizeof(credentials.mqttTopic[0]));
    server.arg(4).toCharArray(credentials.hostnameESP, sizeof(credentials.hostnameESP) / sizeof(credentials.hostnameESP[0]));

	File f = SPIFFS.open("/credentials.txt", "w");
  
	if(f){
		
		f.write(reinterpret_cast<byte*>(&credentials), sizeof(credentials));
	    f.close();
  
	}
	else
	{
		Serial.println("Error writing File credentials.txt");
		
	}

	sprintf(htmlBuffer, R"(
<html>
  <head>
    <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>Chamaeleon</title>
  </head>
  <body>
    <div align='center'>
      <h2>Gerätekonfiguration wurde geändert, starte neu</h2>
    </div>
  </body>
</html>)");

    server.send ( 200, "text/html", htmlBuffer);

    Serial.println("Gerätekonfiguration wurde geändert, starte neu");
    delay(1000);
    ESP.restart();

}

 
void handleOpenConfigSite(){
 
    if(server.arg(0).equals("on")){
        openConfigSite = true;
    
    }

    sprintf(htmlBuffer, R"(
<html>
  <head>
    <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>Chamaeleon</title>
  </head>
  <body>
    <div align='center'>
      <h2>OK</h2>
      <script>setTimeout(function(){ window.location = '/'; },100);</script>
    </div>
  </body>
</html>)");

    server.send ( 200, "text/html", htmlBuffer);

}

void handleSetRed(){
    
	setColor(255, 0, 0, brightness); 
    
    sprintf(htmlBuffer, R"(
<html>
  <head>
    <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>red</title>
  </head>
  <body>
    <div align='center'>
      <h2>Farbe Rot!<br>Wird gemacht</h2>   
      <script>setInterval(function(){ window.location = '/'; },2000);</script>
    </div>
  </body>
</html>)");

  server.send ( 200, "text/html", htmlBuffer );  

}

void handleSetGreen(){
   
	setColor(0, 255, 0, brightness);  
  
    sprintf(htmlBuffer, R"(
<html>\
  <head>\
    <meta name='viewport' content='width=320px'>\
    <meta charset='utf-8'>\
    <title>green</title>\
  </head>\
  <body>\
    <div align='center'>\
      <h2>Farbe Grün!<br>Wird gemacht...</h2>\
      <script>setTimeout(function(){ window.location = '/'; },1000);</script>\
    </div>\
  </body>\
</html>)");
 
  server.send ( 200, "text/html", htmlBuffer );  
  
}

void handleSetBlue(){
   
	setColor(0, 0, 255, brightness);   

    sprintf(htmlBuffer, R"(
<html>
  <head>
  <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>blue</title>
  </head>
  <body>
    <div align='center'>
      <h2>Farbe Blau!<br>Wird gemacht...</h2>
      <script>setTimeout(function(){ window.location = '/'; },1000);</script>
    </div>
  </body>
</html>)");
 
  server.send ( 200, "text/html", htmlBuffer );  
}

void handleSetWhite(){
	
	setColor(255, 255, 255, brightness); //Sollte kein MQTT verfügbar sein, muss die Funktion manuell aufgerufen werden
  
    sprintf(htmlBuffer, R"(
<html>
  <head>
  <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>white</title>
  </head>
  <body>
    <div align='center'>
      <h2>Farbe Weiß!<br>Wird gemacht...</h2>
      <script>setTimeout(function(){ window.location = '/'; },1000);</script>
    </div>
  </body>
</html>)");
 
  server.send ( 200, "text/html", htmlBuffer );  
}

void handleSetOff(){
    
      fade = false;
      setOff = true;
      setColor(r, g, b, 0);

    sprintf(htmlBuffer, R"(
<html>
  <head>
  <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>off</title>
  </head>
  <body>
    <div align='center'>
      <h2>ausschalten<br>Wird gemacht...</h2>
      <script>setTimeout(function(){ window.location = '/'; },1000);</script>
    </div>
  </body>
</html>)");
 
  server.send ( 200, "text/html", htmlBuffer );  
}

void handleSetBrightness(){
  
	brightness = server.arg(0).toInt();
    
	setColor(r, g, b, brightness);  //Sollte kein MQTT verfügbar sein, muss die Funktion manuell aufgerufen werden 
     
    sprintf(htmlBuffer, R"(
<html>
  <head>
  <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>brightness</title>
  </head>
  <body>
    <div align='center'>
      <h2>Helligkeit wird angepasst...</h2>
      <script>setTimeout(function(){ window.location = '/'; },1000);</script>
    </div>
  </body>
</html>)");
 
  server.send ( 200, "text/html", htmlBuffer ); 
    
}

void handleFade(){
  
  if(server.arg(0).equals("on")){
    
      fade = true;
      fadeState = 0;
    
  }else{
    fade = false;
    setColor(0, 0, 0, brightness);
  }

    sprintf(htmlBuffer, R"(
<html>
  <head>
  <meta name='viewport' content='width=320px'>
    <meta charset='utf-8'>
    <title>RGB</title>
  </head>
  <body>
  <div align='center'>
    <h2>OK</h2>
    <script>setTimeout(function(){ window.location = '/'; },1000);</script>
  </div>
  </body>
</html>)");

  server.send ( 200, "text/html", htmlBuffer);

}
